<html>
<head>
<title>OgreShadowCameraSetupFocused.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShadowCameraSetupFocused.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShadowCameraSetupFocused_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Copyright (c) 2006 Matthias Fink, netAllied GmbH &lt;matthias.fink@web.de&gt;                             </span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00011"></a>00011 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00012"></a>00012 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00013"></a>00013 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00014"></a>00014 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00015"></a>00015 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00016"></a>00016 <span class="comment"></span>
<a name="l00017"></a>00017 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00018"></a>00018 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00021"></a>00021 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00022"></a>00022 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00023"></a>00023 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00024"></a>00024 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00025"></a>00025 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00026"></a>00026 <span class="comment">THE SOFTWARE.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ShadowCameraSetupFocused_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ShadowCameraSetupFocused_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShadowCameraSetup_8h.html">OgreShadowCameraSetup.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgrePolygon_8h.html">OgrePolygon.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreConvexBody_8h.html">OgreConvexBody.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040     <span class="keyword">class </span>ConvexBody;
<a name="l00041"></a>00041 
<a name="l00057"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html" title="Implements the uniform shadow mapping algorithm in focused mode.">FocusedShadowCameraSetup</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ShadowCameraSetup.html" title="This class allows you to plug in new ways to define the camera setup when rendering and projecting sh...">ShadowCameraSetup</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">protected</span>:
<a name="l00067"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a2022a48e9e37aa409682d320233cfa09">00067</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a2022a48e9e37aa409682d320233cfa09" title="Transform to or from light space as defined by Wimmer et al.">msNormalToLightSpace</a>;
<a name="l00068"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a3c6218ad4ccccd28374444f1ecd2b3d5">00068</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a3c6218ad4ccccd28374444f1ecd2b3d5">msLightSpaceToNormal</a>;
<a name="l00069"></a>00069 
<a name="l00073"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a0ebae20e4252d229af9524a8690ecc11">00073</a>         <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>* <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a0ebae20e4252d229af9524a8690ecc11" title="Temporary preallocated frustum to set up a projection matrix in ::calculateShadowMappingMatrix()">mTempFrustum</a>;
<a name="l00074"></a>00074 
<a name="l00077"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a1cdb9e5c72f7bbb936b2ba84cf605787">00077</a>         <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a1cdb9e5c72f7bbb936b2ba84cf605787" title="Temporary preallocated camera to set up a light frustum for clipping in ::calculateB.">mLightFrustumCamera</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a113a55085b7c23a1004a4be9f3155c1c">00078</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a113a55085b7c23a1004a4be9f3155c1c">mLightFrustumCameraCalculated</a>;
<a name="l00079"></a>00079 
<a name="l00081"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#ac22ea363ab7fc61d60f0c1518015cb6b">00081</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#ac22ea363ab7fc61d60f0c1518015cb6b" title="Use tighter focus region?">mUseAggressiveRegion</a>;
<a name="l00082"></a>00082 
<a name="l00085"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">00085</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>
<a name="l00086"></a>00086         {
<a name="l00087"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html#a8ed99e0d43569bb2304494c5f399a6ca">00087</a>             <a class="code" href="classOgre_1_1Polygon.html#a55b73fdabd35c480dd873009c546c20f">Polygon::VertexList</a> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html#a8ed99e0d43569bb2304494c5f399a6ca">mBodyPoints</a>;
<a name="l00088"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html#aef88b74b4b2ab59e7fd26b95ab6f348c">00088</a>             <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>      <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html#aef88b74b4b2ab59e7fd26b95ab6f348c">mAAB</a>;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090         <span class="keyword">public</span>:
<a name="l00091"></a>00091             <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>();
<a name="l00092"></a>00092             <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>&amp; body);
<a name="l00093"></a>00093             ~<a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>();
<a name="l00094"></a>00094 
<a name="l00097"></a>00097             <span class="keywordtype">void</span> merge(<span class="keyword">const</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>&amp; plb);
<a name="l00098"></a>00098 
<a name="l00103"></a>00103             <span class="keywordtype">void</span> build(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>&amp; body, <span class="keywordtype">bool</span> filterDuplicates = <span class="keyword">true</span>);
<a name="l00104"></a>00104 
<a name="l00114"></a>00114             <span class="keywordtype">void</span> buildAndIncludeDirection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>&amp; body, 
<a name="l00115"></a>00115                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrudeDist, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; dir);
<a name="l00116"></a>00116 
<a name="l00119"></a>00119             <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getAAB(<span class="keywordtype">void</span>) <span class="keyword">const</span>;   
<a name="l00120"></a>00120 
<a name="l00123"></a>00123             <span class="keywordtype">void</span> addPoint(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; point);
<a name="l00124"></a>00124 
<a name="l00127"></a>00127             <span class="keywordtype">void</span> addAAB(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; aab);
<a name="l00128"></a>00128 
<a name="l00131"></a>00131             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getPoint(<span class="keywordtype">size_t</span> cnt) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00135"></a>00135             <span class="keywordtype">size_t</span> getPointCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00139"></a>00139             <span class="keywordtype">void</span> reset(<span class="keywordtype">void</span>);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141         };
<a name="l00142"></a>00142 
<a name="l00143"></a>00143         <span class="comment">// Persistent calculations to prevent reallocation</span>
<a name="l00144"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#ae784e0376eb99fa60f2c4a995ccd162e">00144</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#ae784e0376eb99fa60f2c4a995ccd162e">mBodyB</a>;
<a name="l00145"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a84c5bc98d3d36f4e3f858d726d1cb19e">00145</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a84c5bc98d3d36f4e3f858d726d1cb19e">mPointListBodyB</a>;
<a name="l00146"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a69328121d415c6e9033ff0e3d7d21cd2">00146</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a69328121d415c6e9033ff0e3d7d21cd2">mPointListBodyLVS</a>;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148     <span class="keyword">protected</span>:
<a name="l00163"></a>00163         <span class="keywordtype">void</span> calculateShadowMappingMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>&amp; sm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam, 
<a name="l00164"></a>00164             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>&amp; light, <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> *out_view, 
<a name="l00165"></a>00165             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> *out_proj, <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *out_cam) <span class="keyword">const</span>;
<a name="l00166"></a>00166 
<a name="l00186"></a>00186         <span class="keywordtype">void</span> calculateB(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>&amp; sm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>&amp; light, 
<a name="l00187"></a>00187             <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; sceneBB, <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; receiverBB, <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a> *out_bodyB) <span class="keyword">const</span>;
<a name="l00188"></a>00188 
<a name="l00203"></a>00203         <span class="keywordtype">void</span> calculateLVS(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>&amp; sm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>&amp; light,
<a name="l00204"></a>00204             <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; sceneBB, <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a> *out_LVS) <span class="keyword">const</span>;
<a name="l00205"></a>00205 
<a name="l00215"></a>00215         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getLSProjViewDir(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; lightSpace, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam, 
<a name="l00216"></a>00216             <span class="keyword">const</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>&amp; bodyLVS) <span class="keyword">const</span>;
<a name="l00217"></a>00217 
<a name="l00227"></a>00227         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getNearCameraPoint_ws(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; viewMatrix, 
<a name="l00228"></a>00228             <span class="keyword">const</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>&amp; bodyLVS) <span class="keyword">const</span>;
<a name="l00229"></a>00229 
<a name="l00239"></a>00239         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> transformToUnitCube(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; m, <span class="keyword">const</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>&amp; body) <span class="keyword">const</span>;
<a name="l00240"></a>00240 
<a name="l00245"></a>00245         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> buildViewMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pos, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; dir, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; up) <span class="keyword">const</span>;
<a name="l00246"></a>00246 
<a name="l00247"></a>00247     <span class="keyword">public</span>:
<a name="l00252"></a>00252         <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html" title="Implements the uniform shadow mapping algorithm in focused mode.">FocusedShadowCameraSetup</a>(<span class="keywordtype">void</span>);
<a name="l00253"></a>00253 
<a name="l00258"></a>00258         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html" title="Implements the uniform shadow mapping algorithm in focused mode.">FocusedShadowCameraSetup</a>(<span class="keywordtype">void</span>);
<a name="l00259"></a>00259 
<a name="l00262"></a>00262         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getShadowCamera(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> *sm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *cam, 
<a name="l00263"></a>00263             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a> *light, <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *texCam, <span class="keywordtype">size_t</span> iteration) <span class="keyword">const</span>;
<a name="l00264"></a>00264 
<a name="l00278"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#af57854c45cd48033da1cb28e316901dc">00278</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#af57854c45cd48033da1cb28e316901dc" title="Sets whether or not to use the more aggressive approach to deciding on the focus region or not...">setUseAggressiveFocusRegion</a>(<span class="keywordtype">bool</span> aggressive) { mUseAggressiveRegion = aggressive; }
<a name="l00279"></a>00279 
<a name="l00280"></a><a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a89fc1444a88d8c20c35ee50a8c518564">00280</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html#a89fc1444a88d8c20c35ee50a8c518564">getUseAggressiveFocusRegion</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseAggressiveRegion; }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282     };
<a name="l00283"></a>00283 
<a name="l00287"></a>00287 }
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
